/*
NCSA Portfolio was developed by Stephen Pietrowicz and Chris Heistad
at the National Center for Supercomputing Applications, and is
Copyright 1997-1999 by the Board of Trustees of the University of Illinois.

The original source code is no longer available.  The source below is
the result of decompilation of the Java binary files.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/




// Decompiled by Jad v1.5.8c. Copyright 2001 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/kpdus/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   MultipleDirective.java

package ncsa.j3d.loaders.play.directives;

import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Vector;
import ncsa.j3d.loaders.play.PlayReader;
import ncsa.util.ReaderTokenizer;

// Referenced classes of package ncsa.j3d.loaders.play.directives:
//            Directive

public class MultipleDirective extends Directive
{

    public MultipleDirective()
    {
        directives = new Vector();
    }

    public void execute()
    {
        for(Enumeration enumeration = directives.elements(); enumeration.hasMoreElements(); ((Directive)enumeration.nextElement()).execute());
    }

    public long getTime()
    {
        long l = 0L;
        for(Enumeration enumeration = directives.elements(); enumeration.hasMoreElements();)
            l = Math.max(l, ((Directive)enumeration.nextElement()).getTime());

        return l;
    }

    public void initialize(ReaderTokenizer readertokenizer)
    {
        while(readertokenizer.nextToken() != -103 && !readertokenizer.sval.equalsIgnoreCase("END")) 
            try
            {
                if(readertokenizer.ttype == -101)
                {
                    Directive directive = (Directive)Class.forName(readertokenizer.sval).newInstance();
                    super.reader.initializeDirective(directive);
                    directive.initialize(readertokenizer);
                    directives.addElement(directive);
                }
            }
            catch(Exception exception)
            {
                System.out.println(toString());
                System.out.println(exception);
            }
    }

    public boolean intermediate(long l)
    {
        for(Enumeration enumeration = directives.elements(); enumeration.hasMoreElements();)
        {
            Directive directive = (Directive)enumeration.nextElement();
            if(directive.getTime() > l)
                directive.intermediate(l);
        }

        return l < getTime();
    }

    public void reset()
    {
        for(Enumeration enumeration = directives.elements(); enumeration.hasMoreElements(); ((Directive)enumeration.nextElement()).reset());
    }

    public String toString()
    {
        return "ncsa.j3d.loaders.play.directives.MultipleDirective";
    }

    public void undo()
    {
    }

    public void write(PrintWriter printwriter)
    {
        printwriter.println(toString());
        for(Enumeration enumeration = directives.elements(); enumeration.hasMoreElements(); printwriter.println(((Directive)enumeration.nextElement()).toString()));
        printwriter.println("END");
    }

    Vector directives;
}
